package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.MemberPoint;
import com.izouma.awesomeadmin.service.MemberPointService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/memberPoint")
@RequiresAuthentication
public class MemberPointController {

    @Autowired
    private MemberPointService memberPointService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(MemberPoint record) {
        List<MemberPoint> pp = memberPointService.getMemberPointList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getMemberPoint", method = RequestMethod.GET)
    @ResponseBody
    public Result getMemberPoint(@RequestParam(required = false, value = "id") String id) {
        MemberPoint data = memberPointService.getMemberPointById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(MemberPoint record) {
        MemberPoint data = memberPointService.getMemberPoint(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, MemberPoint record) {
        Map<String, Object> result = new HashMap<>();

        List<MemberPoint> pp =memberPointService.getMemberPointByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(MemberPoint record) {
        boolean num = memberPointService.createMemberPoint(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateMemberPoint(MemberPoint record) {
        boolean num = memberPointService.updateMemberPoint(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteMemberPoint(@RequestParam(required = true, value = "id") String id) {

        boolean num = memberPointService.deleteMemberPoint(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, MemberPoint record) throws Exception {

    List<MemberPoint> memberPoints = memberPointService.getMemberPointList(record);


        String sheetName = "member_point";
        String titleName = "用户积分数据表";
        String fileName = "用户积分表";
        int columnNumber = 12;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "用户" ,   "订单" ,   "变化数量" ,   "剩余金额" ,   "类型" ,   "备注"  };
        String[][] dataList = new String[memberPoints.size()][12];

        for (int i = 0; i < memberPoints.size(); i++) {

                        dataList[i][0] = String.valueOf(memberPoints.get(i).getId());
                        dataList[i][1] = String.valueOf(memberPoints.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(memberPoints.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(memberPoints.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(memberPoints.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(memberPoints.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(memberPoints.get(i).getUserId());
                        dataList[i][7] = String.valueOf(memberPoints.get(i).getOrderId());
                        dataList[i][8] = String.valueOf(memberPoints.get(i).getMoney());
                        dataList[i][9] = String.valueOf(memberPoints.get(i).getBalance());
                        dataList[i][10] = String.valueOf(memberPoints.get(i).getTypeFlag());
                        dataList[i][11] = String.valueOf(memberPoints.get(i).getRemark());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

